//SaveVersion.jsx
//Javascript by Jeremy Bowman
//This script saves successive versions of the current document, incrementing a number
//at the end of the document name as it does so.
//The first time the script is run, if there is no number at the end of the document name,
//it will create a new folder in the same place as the original document, and put a first
//numbered version of the document into it (so mynovel.indd becomes mynovel-1.indd,
//saved in a new folder called "mynovel (numbered versions)".
//In subsequent runs, it adds newer versions to the folder (so mynovel-1.indd is joined by
//mynovel-2.indd, mynovel-3.indd, and so on (up to mynovel-99.indd).
//If the document name already has a number at the end, then the script saves a new version
//alongside the original and increments the number, but does not create a new folder.
//An earlier version of this script relied on script labelling, and so needed at least one
//text frame in the document. That issue is resolved in this version, which does not use
//script labelling, and the document contents do not affect the running of the script.
app.activeDocument.save();
var myName = app.activeDocument.name;
var myLength = myName.length;
var myPath = app.activeDocument.filePath + "/";
var myProperName = myName.substring(0,myLength-5);
var myProperLength = myProperName.length - 1;
var myLastChar = myProperName[myProperLength];
var myLastNumber = parseInt(myLastChar);
var myVersionNumber = 0;
if (chk_val(myLastNumber) == false) {
	myVersionNumber = 1;
	var myFolder = new Folder(myPath + myProperName +" (numbered versions)");
	if (!myFolder.exists) {
		myFolder.create();
		}
	app.activeDocument.save(new File(myFolder +"/" + myProperName+"-1.indd"));
	}

if (chk_val(myLastNumber) == true){
	var mySecondLastChar = myProperName[myProperLength - 1];
	var mySecondLastNumber= parseInt(mySecondLastChar);
	if (chk_val(mySecondLastNumber) == false) {
		myVersionNumber = myLastNumber;
		myDigits = 1;
		}
	else {
		myVersionNumber = mySecondLastNumber*10 + myLastNumber;
		myDigits = 2;
		}
	var myBite = 5 + myDigits;
	var myProperName = myName.substring(0,myLength-myBite);
	var myNext = new Folder(myPath + myProperName);
	myVersionNumber++;
	app.activeDocument.save(new File(myNext+myVersionNumber+".indd"));
	}

function chk_val(val){
	return /^\d+$/.test(val);
	}